
;source file for CapsLock program - DednDave 4-2011

;########################################################################

        INCLUDE CapsLock.inc

;########################################################################

;tooltip delay times

DT_Show    EQU 2500  ;duration to show in mS
DT_Initial EQU 100   ;duration before show in mS
DT_Reshow  EQU 200   ;duration before reshow in mS

;########################################################################

        .DATA

szTitle   db 'Caps Lock Demo',0
MBTitle1  db 'User ID',0
MBTitle2  db 'Password',0
szTTClass db 'tooltips_class32',0
MsgEcTt0  db 'Caps Lock is On',0
MsgEcTt1  db 'Having Caps Lock on may cause you to enter your Password incorrectly.',0

;************************************************************************

        .DATA?

hInstance dd ?
hDlg      dd ?
hStatic   dd ?
hEdit1    dd ?
hEdit2    dd ?
hFocus    dd ?
hKbHook   dd ?
EditProc  dd ?
LineBuf   db 32 dup(?)

;########################################################################

        .CODE

DlgProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     ecx,uMsg
        cmp     ecx,WM_KEYDOWN
        jz      dProc1

        cmp     ecx,WM_CLOSE
        jz      dProc5

        cmp     ecx,WM_INITDIALOG
        jnz     dProc0

;--------------------------------

;WM_INITDIALOG

        push    ebx
        mov     ebx,hWnd
        mov     hDlg,ebx
        INVOKE  SetWindowText,ebx,offset szTitle
        INVOKE  LoadIcon,hInstance,IDI_ICON
        push    eax
        INVOKE  SendMessage,ebx,WM_SETICON,ICON_SMALL,eax
        pop     eax
        INVOKE  SendMessage,ebx,WM_SETICON,ICON_BIG,eax
        INVOKE  GetDlgItem,ebx,CID_STC1
        mov     hStatic,eax
        INVOKE  GetDlgItem,ebx,CID_EDT1
        mov     hEdit1,eax
        INVOKE  SendMessage,eax,EM_SETMARGINS,EC_LEFTMARGIN or EC_RIGHTMARGIN,0
        INVOKE  SetFocus,hEdit1
        INVOKE  GetDlgItem,ebx,CID_EDT2
        mov     hEdit2,eax
        xchg    eax,ebx
        INVOKE  SendMessage,ebx,EM_SETPASSWORDCHAR,'*',0
        INVOKE  SendMessage,ebx,EM_SETMARGINS,EC_LEFTMARGIN or EC_RIGHTMARGIN,0
        INVOKE  SetWindowLong,ebx,GWL_WNDPROC,EditProc2
        mov     EditProc,eax
        INVOKE  GetCurrentThreadId
        INVOKE  SetWindowsHookEx,WH_KEYBOARD,KeyboardProc,0,eax
        mov     hKbHook,eax
        pop     ebx

;--------------------------------

;return 0

dProc0: xor     eax,eax
        ret

;--------------------------------

;WM_KEYDOWN

dProc1: cmp     wParam,VK_RETURN
        jnz     dProc0

        INVOKE  GetFocus
        cmp     eax,hEdit1
        jz      dProc2

        cmp     eax,hEdit2
        jnz     dProc0

dProc2: push    ebx
        mov word ptr LineBuf,sizeof LineBuf-1
        xchg    eax,ebx
        INVOKE  SendMessage,ebx,EM_GETLINE,0,offset LineBuf
        mov     edx,offset MBTitle1
        cmp     ebx,hEdit1
        jz      dProc3

        mov     edx,offset MBTitle2

dProc3: INVOKE  MessageBox,hDlg,offset LineBuf,edx,MB_OK
        mov     edx,hEdit2
        mov     eax,hStatic
        cmp     ebx,edx
        jz      dProc4

        xchg    eax,edx

dProc4: INVOKE  SetFocus,eax
        pop     ebx
        jmp     dProc0

;--------------------------------

;WM_CLOSE

dProc5: INVOKE  UnhookWindowsHookEx,hKbHook
        INVOKE  EndDialog,hWnd,0
        jmp     dProc0

DlgProc ENDP

;************************************************************************

EditProc2 PROC  hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        cmp     uMsg,EM_SHOWBALLOONTIP
        jz      eProc0

        INVOKE  CallWindowProc,EditProc,hWnd,uMsg,wParam,lParam
        ret

eProc0: xor     eax,eax
        ret     16

EditProc2 ENDP

;************************************************************************

KeyboardProc PROC    nCode:SDWORD,wParam:WPARAM,lParam:LPARAM

;keyboard hook proc

        test byte ptr nCode+3,80h       ;if nCode is negative, call next hook
        jz      kProc1

kProc0: INVOKE  CallNextHookEx,hKbHook,nCode,wParam,lParam
        ret

kProc1: test byte ptr lParam+3,40h      ;only key down - not key up
        jnz     kProc0

        mov     ecx,wParam
        cmp     ecx,VK_RETURN           ;enter key
        jnz     kProc0

        INVOKE  SendMessage,hDlg,WM_KEYDOWN,ecx,lParam
        jmp     kProc0

KeyboardProc ENDP

;************************************************************************

_main   PROC

        xor     edi,edi
        push    ICC_WIN95_CLASSES
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        pop     ecx
        pop     edx
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        INVOKE  DialogBoxParam,eax,CID_DIALOG1,edi,DlgProc,edi
        INVOKE  ExitProcess,eax

_main   ENDP

;########################################################################

        END     _main

